/*
Copyright 2021 Loft Labs Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "github.com/loft-sh/jspolicy/pkg/apis/policy/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeJsPolicyBundles implements JsPolicyBundleInterface
type FakeJsPolicyBundles struct {
	Fake *FakePolicyV1beta1
}

var jspolicybundlesResource = schema.GroupVersionResource{Group: "policy.jspolicy.com", Version: "v1beta1", Resource: "jspolicybundles"}

var jspolicybundlesKind = schema.GroupVersionKind{Group: "policy.jspolicy.com", Version: "v1beta1", Kind: "JsPolicyBundle"}

// Get takes name of the jsPolicyBundle, and returns the corresponding jsPolicyBundle object, and an error if there is any.
func (c *FakeJsPolicyBundles) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.JsPolicyBundle, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(jspolicybundlesResource, name), &v1beta1.JsPolicyBundle{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.JsPolicyBundle), err
}

// List takes label and field selectors, and returns the list of JsPolicyBundles that match those selectors.
func (c *FakeJsPolicyBundles) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.JsPolicyBundleList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(jspolicybundlesResource, jspolicybundlesKind, opts), &v1beta1.JsPolicyBundleList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.JsPolicyBundleList{ListMeta: obj.(*v1beta1.JsPolicyBundleList).ListMeta}
	for _, item := range obj.(*v1beta1.JsPolicyBundleList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested jsPolicyBundles.
func (c *FakeJsPolicyBundles) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(jspolicybundlesResource, opts))
}

// Create takes the representation of a jsPolicyBundle and creates it.  Returns the server's representation of the jsPolicyBundle, and an error, if there is any.
func (c *FakeJsPolicyBundles) Create(ctx context.Context, jsPolicyBundle *v1beta1.JsPolicyBundle, opts v1.CreateOptions) (result *v1beta1.JsPolicyBundle, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(jspolicybundlesResource, jsPolicyBundle), &v1beta1.JsPolicyBundle{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.JsPolicyBundle), err
}

// Update takes the representation of a jsPolicyBundle and updates it. Returns the server's representation of the jsPolicyBundle, and an error, if there is any.
func (c *FakeJsPolicyBundles) Update(ctx context.Context, jsPolicyBundle *v1beta1.JsPolicyBundle, opts v1.UpdateOptions) (result *v1beta1.JsPolicyBundle, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(jspolicybundlesResource, jsPolicyBundle), &v1beta1.JsPolicyBundle{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.JsPolicyBundle), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeJsPolicyBundles) UpdateStatus(ctx context.Context, jsPolicyBundle *v1beta1.JsPolicyBundle, opts v1.UpdateOptions) (*v1beta1.JsPolicyBundle, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(jspolicybundlesResource, "status", jsPolicyBundle), &v1beta1.JsPolicyBundle{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.JsPolicyBundle), err
}

// Delete takes name of the jsPolicyBundle and deletes it. Returns an error if one occurs.
func (c *FakeJsPolicyBundles) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(jspolicybundlesResource, name), &v1beta1.JsPolicyBundle{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeJsPolicyBundles) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(jspolicybundlesResource, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.JsPolicyBundleList{})
	return err
}

// Patch applies the patch and returns the patched jsPolicyBundle.
func (c *FakeJsPolicyBundles) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.JsPolicyBundle, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(jspolicybundlesResource, name, pt, data, subresources...), &v1beta1.JsPolicyBundle{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.JsPolicyBundle), err
}
